package info.aspirecn.cloud.yysj.utils;

import org.elasticsearch.index.query.BoolQueryBuilder;
import org.elasticsearch.index.query.QueryBuilders;
import org.elasticsearch.search.builder.SearchSourceBuilder;

import java.lang.reflect.Field;
import java.util.Map;

/**
 * Email:lixinxu@aspirecn.com
 * Descrption:
 */
public class ElasticSearchAddParamUtil {


    public static void addParam(BoolQueryBuilder boolQueryBuilder, Object obj, Map<String, Integer> outFields){
        Field[] fields = obj.getClass().getDeclaredFields();
        for (int i = 0; i < fields.length; i++){
            Field field = fields[i];
            field.setAccessible(true);

            if(outFields.get(field.getName()) != null){
                continue;
            }

            try {
                Object value = field.get(obj);
                if(value != null && value != ""){
                    boolQueryBuilder.must(QueryBuilders.termsQuery(field.getName(),value));
                }
            } catch (IllegalAccessException e) {
                e.printStackTrace();
            }
        }
    }

    public static void addParamKeyword(SearchSourceBuilder searchSourceBuilder, Object obj, Map<String, Integer> outFields){
        Field[] fields = obj.getClass().getDeclaredFields();
        for (int i = 0; i < fields.length; i++){
            Field field = fields[i];
            field.setAccessible(true);

            if(outFields.get(field.getName()) != null){
                continue;
            }

            try {
                Object value = field.get(obj);
                if(value != null && value != ""){
                    searchSourceBuilder.query(QueryBuilders.boolQuery().must(QueryBuilders.termsQuery(field.getName()+".keyword",value)));
                }
            } catch (IllegalAccessException e) {
                e.printStackTrace();
            }
        }
    }

}
